
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all; 

ENTITY Ram IS
PORT (
Clk : IN std_logic;
btn : in std_logic_vector(3 downto 0);
swt:  in std_logic_vector(7 downto 0);
txd_done1:in std_logic;
txd_done2:in std_logic;
txd_done3:in std_logic;
checksum_wert:OUT std_logic_vector(7 DOWNTO 0);
Datain : IN std_logic_vector(7 DOWNTO 0);
Read_Row_address : IN std_logic_vector(3 DOWNTO 0);
Read_word_address : IN std_logic_vector(3 DOWNTO 0);
ram_loschen: in std_logic;
rest:out std_logic_vector(7 downto 0);
a_zaehler:IN std_logic_vector(7 DOWNTO 0);
data_fertig_schalter:in std_logic;
txd_data_1:out std_logic_vector(7 DOWNTO 0);
txd_data_2:out std_logic_vector(7 DOWNTO 0);
txd_data_3:out std_logic_vector(7 DOWNTO 0);
zahl_raus: out std_logic_vector(7 downto 0);
dataout : OUT std_logic_vector(7 DOWNTO 0)
);
END Ram;


ARCHITECTURE Behavioral OF Ram IS

TYPE Row IS ARRAY ( 10 DOWNTO 0) OF std_logic_vector (7 DOWNTO 0);
TYPE mem_type IS ARRAY ( 12 DOWNTO 0) OF Row;
SIGNAL mem : mem_type;

TYPE RAM_array IS ARRAY ( 0 to 13) OF std_logic_vector(7 downto 0);
signal bewegen: RAM_array;

signal a,c: integer range 0 to 255:=0;
signal b,d: integer range 0 to 10:=0;
signal luck,luck2: std_logic:='0';
signal checksum_schalter: std_logic:='0';
signal b_zaehler_schalter,temp: std_logic_vector (7 DOWNTO 0):="00000000";
signal checksum:std_logic_vector (7 DOWNTO 0):="00000000";
signal Ram_state,motor:integer range 0 to 2:=0;
signal LTxd_Done_1,LTxd_Done_2,LTxd_Done_3: std_logic;
signal motor1,motor2,motor3:integer:=0 ;
signal Ram_state_1: integer range 0 to 6:=0;
signal zzahler: integer:=0;
signal cnttemp : integer:=0;
signal Low_takt:std_logic;
signal takt_verteil: integer:=0;
signal speed_waehlen: std_logic_vector (7 DOWNTO 0):="00000000";
	
BEGIN 

process (Clk)
variable aa: integer:=0;
variable drehwinkel,speed:std_logic_vector(7 downto 0);
--variable speed_waehlen: std_logic_vector (7 DOWNTO 0):="00000000";
BEGIN 
IF ( Clk'event AND Clk = '1') THEN
	rest<=conv_std_logic_vector(255-a,8);
if ram_loschen='1' then
	case c is
			when 0 to 12 =>		
				case d is
					when 0 to 9 =>
						mem(c)(d)<="00000000";
						d<=d+1;
						
					when 10 =>
						mem(c)(d)<="00000000";
						c<=c+1;
						d<=0;
						
					when others =>
				end case;
			
			when others =>
		 end case;
end if;
 
 if b_zaehler_schalter=a_zaehler then
 
	b_zaehler_schalter<=b_zaehler_schalter+1;
	
	if b_zaehler_schalter="00000000" then
		temp<=datain;
	else	
		 case a is
			when 0 to 12 =>		
				case b is
					when 0 to 9=>
						mem(a)(b)<=datain;
						b<=b+1;
						

						
					when 10 =>
					mem(a)(b)<=datain;
					aa:=a;
					checksum_schalter<='1';
					checksum<=conv_std_logic_vector(((conv_integer (mem(aa)(1))+conv_integer(mem(aa)(2))+conv_integer(mem(aa)(4))+conv_integer(mem(aa)(5))+conv_integer(mem(aa)(6))+conv_integer(mem(aa)(7))+conv_integer(mem(aa)(8))+conv_integer(mem(aa)(9))) mod 256),8);
					a<=a+1;
					b<=0;
						
					when others =>
				end case;
			
			when others =>
		 end case;
	 end if;
	 
 end if;
 
------------------------------------------------------------------------------------
--checksum rechnen 
------------------------------------------------------------------------------------
if checksum_schalter='1' then
	if checksum= mem(aa)(10) then
		checksum_wert<=conv_std_logic_vector(245,8);
		checksum_schalter<='0';
	end if;
end if;						
----------------------------------------------------------------------------------
--Data von Ram ausnehmen
----------------------------------------------------------------------------------
if swt="00000001" then

	dataout<=conv_std_logic_vector(Ram_state_1,8);
case Ram_state_1 is
		
	when 0 to 6 =>

		case Ram_state is
			when 0=> 
						drehwinkel:=mem(Ram_state_1+1)(4);
						speed:=mem(Ram_state_1)(4);

			when 1=> 
						drehwinkel:=mem(Ram_state_1+1)(5);
						speed:=mem(Ram_state_1)(5);

			when 2=> 
						drehwinkel:=mem(Ram_state_1+1)(6);
						speed:=mem(Ram_state_1)(6);

			when others =>		
						Ram_state<=0;
		end case;
	
	when others=>

end case;

case conv_integer(speed) is
				when 1 to 10=>
					bewegen(0)<=conv_std_logic_vector(128,8);
					bewegen(1)<=conv_std_logic_vector(233,8);
					bewegen(2)<=conv_std_logic_vector(0,8);
					bewegen(3)<=conv_std_logic_vector(10,8); 
					bewegen(4)<=conv_std_logic_vector(141,8);
					bewegen(5)<=conv_std_logic_vector(0,8);
					bewegen(6)<=conv_std_logic_vector(0,8);
				
				when 11 to 20=>
					bewegen(0)<=conv_std_logic_vector(128,8);
					bewegen(1)<=conv_std_logic_vector(233,8);
					bewegen(2)<=conv_std_logic_vector(0,8);
					bewegen(3)<=conv_std_logic_vector(20,8); 
					bewegen(4)<=conv_std_logic_vector(131,8);
					bewegen(5)<=conv_std_logic_vector(0,8);
					bewegen(6)<=conv_std_logic_vector(0,8);
				
				when 21 to 30=>
					bewegen(0)<=conv_std_logic_vector(128,8);
					bewegen(1)<=conv_std_logic_vector(233,8);
					bewegen(2)<=conv_std_logic_vector(0,8);
					bewegen(3)<=conv_std_logic_vector(30,8); 
					bewegen(4)<=conv_std_logic_vector(121,8);
					bewegen(5)<=conv_std_logic_vector(0,8);
					bewegen(6)<=conv_std_logic_vector(0,8);
				when 31 to 40=>
					bewegen(0)<=conv_std_logic_vector(128,8);
					bewegen(1)<=conv_std_logic_vector(233,8);
					bewegen(2)<=conv_std_logic_vector(0,8);
					bewegen(3)<=conv_std_logic_vector(40,8); 
					bewegen(4)<=conv_std_logic_vector(111,8);
					bewegen(5)<=conv_std_logic_vector(0,8);
					bewegen(6)<=conv_std_logic_vector(0,8);
				when 41 to 50=>
					bewegen(0)<=conv_std_logic_vector(128,8);
					bewegen(1)<=conv_std_logic_vector(233,8);
					bewegen(2)<=conv_std_logic_vector(0,8);
					bewegen(3)<=conv_std_logic_vector(50,8); 
					bewegen(4)<=conv_std_logic_vector(101,8);
					bewegen(5)<=conv_std_logic_vector(0,8);
					bewegen(6)<=conv_std_logic_vector(0,8);
				when 51 to 60=>
					bewegen(0)<=conv_std_logic_vector(128,8);
					bewegen(1)<=conv_std_logic_vector(233,8);
					bewegen(2)<=conv_std_logic_vector(0,8);
					bewegen(3)<=conv_std_logic_vector(60,8); 
					bewegen(4)<=conv_std_logic_vector(91,8);
					bewegen(5)<=conv_std_logic_vector(0,8);
					bewegen(6)<=conv_std_logic_vector(0,8);

				when 61 to 70=>
					bewegen(0)<=conv_std_logic_vector(128,8);
					bewegen(1)<=conv_std_logic_vector(233,8);
					bewegen(2)<=conv_std_logic_vector(0,8);
					bewegen(3)<=conv_std_logic_vector(70,8); 
					bewegen(4)<=conv_std_logic_vector(81,8);
					bewegen(5)<=conv_std_logic_vector(0,8);
					bewegen(6)<=conv_std_logic_vector(0,8);
				when 71 to 80=>
					bewegen(0)<=conv_std_logic_vector(128,8);
					bewegen(1)<=conv_std_logic_vector(233,8);
					bewegen(2)<=conv_std_logic_vector(0,8);
					bewegen(3)<=conv_std_logic_vector(80,8); 
					bewegen(4)<=conv_std_logic_vector(71,8);
					bewegen(5)<=conv_std_logic_vector(0,8);
					bewegen(6)<=conv_std_logic_vector(0,8);
				when 81 to 90=>
					bewegen(0)<=conv_std_logic_vector(128,8);
					bewegen(1)<=conv_std_logic_vector(233,8);
					bewegen(2)<=conv_std_logic_vector(0,8);
					bewegen(3)<=conv_std_logic_vector(90,8); 
					bewegen(4)<=conv_std_logic_vector(61,8);
					bewegen(5)<=conv_std_logic_vector(0,8);
					bewegen(6)<=conv_std_logic_vector(0,8);
				when 91 to 100=>
					bewegen(0)<=conv_std_logic_vector(128,8);
					bewegen(1)<=conv_std_logic_vector(233,8);
					bewegen(2)<=conv_std_logic_vector(0,8);
					bewegen(3)<=conv_std_logic_vector(100,8); 
					bewegen(4)<=conv_std_logic_vector(51,8);
					bewegen(5)<=conv_std_logic_vector(0,8);
					bewegen(6)<=conv_std_logic_vector(0,8);
				when others=>
			end case;


case conv_integer(drehwinkel) is
				when 5 to 10=>
					bewegen(7)<=conv_std_logic_vector(128,8);
					bewegen(8)<=conv_std_logic_vector(246,8);
					bewegen(9)<=conv_std_logic_vector(2,8);
					bewegen(10)<=conv_std_logic_vector(188,8); 
					bewegen(11)<=conv_std_logic_vector(204,8);
					bewegen(12)<=conv_std_logic_vector(0,8);
					bewegen(13)<=conv_std_logic_vector(0,8);
				
				when 11 to 20=>
					bewegen(7)<=conv_std_logic_vector(128,8);
					bewegen(8)<=conv_std_logic_vector(246,8);
					bewegen(9)<=conv_std_logic_vector(3,8);
					bewegen(10)<=conv_std_logic_vector(32,8); 
					bewegen(11)<=conv_std_logic_vector(103,8);
					bewegen(12)<=conv_std_logic_vector(0,8);
					bewegen(13)<=conv_std_logic_vector(0,8);
				
				when 21 to 30=>
					bewegen(7)<=conv_std_logic_vector(128,8);
					bewegen(8)<=conv_std_logic_vector(246,8);
					bewegen(9)<=conv_std_logic_vector(3,8);
					bewegen(10)<=conv_std_logic_vector(132,8); 
					bewegen(11)<=conv_std_logic_vector(3,8);
					bewegen(12)<=conv_std_logic_vector(0,8);
					bewegen(13)<=conv_std_logic_vector(0,8);
				when 31 to 40=>
					bewegen(7)<=conv_std_logic_vector(128,8);
					bewegen(8)<=conv_std_logic_vector(246,8);
					bewegen(9)<=conv_std_logic_vector(3,8);
					bewegen(10)<=conv_std_logic_vector(24,8); 
					bewegen(11)<=conv_std_logic_vector(111,8);
					bewegen(12)<=conv_std_logic_vector(0,8);
					bewegen(13)<=conv_std_logic_vector(0,8);
				when 41 to 50=>
					bewegen(7)<=conv_std_logic_vector(128,8);
					bewegen(8)<=conv_std_logic_vector(246,8);
					bewegen(9)<=conv_std_logic_vector(4,8);
					bewegen(10)<=conv_std_logic_vector(76,8); 
					bewegen(11)<=conv_std_logic_vector(58,8);
					bewegen(12)<=conv_std_logic_vector(0,8);
					bewegen(13)<=conv_std_logic_vector(0,8);
				when 51 to 60=>
					bewegen(7)<=conv_std_logic_vector(128,8);
					bewegen(8)<=conv_std_logic_vector(246,8);
					bewegen(9)<=conv_std_logic_vector(4,8);
					bewegen(10)<=conv_std_logic_vector(176,8); 
					bewegen(11)<=conv_std_logic_vector(214,8);
					bewegen(12)<=conv_std_logic_vector(0,8);
					bewegen(13)<=conv_std_logic_vector(0,8);	
				when 61 to 70=>
					bewegen(7)<=conv_std_logic_vector(128,8);
					bewegen(8)<=conv_std_logic_vector(246,8);
					bewegen(9)<=conv_std_logic_vector(5,8);
					bewegen(10)<=conv_std_logic_vector(20,8); 
					bewegen(11)<=conv_std_logic_vector(113,8);
					bewegen(12)<=conv_std_logic_vector(0,8);
					bewegen(13)<=conv_std_logic_vector(0,8);
				when 71 to 80=>
					bewegen(7)<=conv_std_logic_vector(128,8);
					bewegen(8)<=conv_std_logic_vector(246,8);
					bewegen(9)<=conv_std_logic_vector(5,8);
					bewegen(10)<=conv_std_logic_vector(120,8); 
					bewegen(11)<=conv_std_logic_vector(13,8);
					bewegen(12)<=conv_std_logic_vector(0,8);
					bewegen(13)<=conv_std_logic_vector(0,8);
				when 81 to 90=>
					bewegen(7)<=conv_std_logic_vector(128,8);
					bewegen(8)<=conv_std_logic_vector(246,8);
					bewegen(9)<=conv_std_logic_vector(5,8);
					bewegen(10)<=conv_std_logic_vector(220,8); 
					bewegen(11)<=conv_std_logic_vector(169,8);
					bewegen(12)<=conv_std_logic_vector(0,8);
					bewegen(13)<=conv_std_logic_vector(0,8);
				when 91 to 100=>
					bewegen(7)<=conv_std_logic_vector(128,8);
					bewegen(8)<=conv_std_logic_vector(246,8);
					bewegen(9)<=conv_std_logic_vector(6,8);
					bewegen(10)<=conv_std_logic_vector(64,8); 
					bewegen(11)<=conv_std_logic_vector(68,8);
					bewegen(12)<=conv_std_logic_vector(0,8);
					bewegen(13)<=conv_std_logic_vector(0,8);
					
				when 101 to 110=>
					bewegen(7)<=conv_std_logic_vector(128,8);
					bewegen(8)<=conv_std_logic_vector(246,8);
					bewegen(7)<=conv_std_logic_vector(6,8);
					bewegen(9)<=conv_std_logic_vector(164,8); 
					bewegen(10)<=conv_std_logic_vector(224,8);
					bewegen(12)<=conv_std_logic_vector(0,8);
					bewegen(13)<=conv_std_logic_vector(0,8);
				when 111 to 120=>
					bewegen(7)<=conv_std_logic_vector(128,8);
					bewegen(8)<=conv_std_logic_vector(246,8);
					bewegen(9)<=conv_std_logic_vector(7,8);
					bewegen(10)<=conv_std_logic_vector(8,8); 
					bewegen(11)<=conv_std_logic_vector(123,8);
					bewegen(12)<=conv_std_logic_vector(0,8);
					bewegen(13)<=conv_std_logic_vector(0,8);
				when 121 to 130=>
					bewegen(7)<=conv_std_logic_vector(128,8);
					bewegen(8)<=conv_std_logic_vector(246,8);
					bewegen(9)<=conv_std_logic_vector(7,8);
					bewegen(10)<=conv_std_logic_vector(108,8); 
					bewegen(11)<=conv_std_logic_vector(23,8);
					bewegen(12)<=conv_std_logic_vector(0,8);
					bewegen(13)<=conv_std_logic_vector(0,8);
				when 131 to 140=>
					bewegen(7)<=conv_std_logic_vector(128,8);
					bewegen(8)<=conv_std_logic_vector(246,8);
					bewegen(9)<=conv_std_logic_vector(7,8);
					bewegen(10)<=conv_std_logic_vector(208,8); 
					bewegen(11)<=conv_std_logic_vector(179,8);
					bewegen(12)<=conv_std_logic_vector(0,8);
					bewegen(13)<=conv_std_logic_vector(0,8);
				when 141 to 150=>
					bewegen(7)<=conv_std_logic_vector(128,8);
					bewegen(8)<=conv_std_logic_vector(246,8);
					bewegen(9)<=conv_std_logic_vector(8,8);
					bewegen(10)<=conv_std_logic_vector(34,8); 
					bewegen(11)<=conv_std_logic_vector(78,8);
					bewegen(12)<=conv_std_logic_vector(0,8);
					bewegen(13)<=conv_std_logic_vector(0,8);
				when 151 to 160=>
					bewegen(7)<=conv_std_logic_vector(128,8);
					bewegen(8)<=conv_std_logic_vector(246,8);
					bewegen(9)<=conv_std_logic_vector(8,8);
					bewegen(10)<=conv_std_logic_vector(98,8); 
					bewegen(11)<=conv_std_logic_vector(234,8);
					bewegen(12)<=conv_std_logic_vector(0,8);
					bewegen(13)<=conv_std_logic_vector(0,8);
				when 161 to 170=>
					bewegen(7)<=conv_std_logic_vector(128,8);
					bewegen(8)<=conv_std_logic_vector(246,8);
					bewegen(9)<=conv_std_logic_vector(8,8);
					bewegen(10)<=conv_std_logic_vector(252,8); 
					bewegen(11)<=conv_std_logic_vector(134,8);
					bewegen(12)<=conv_std_logic_vector(0,8);
					bewegen(13)<=conv_std_logic_vector(0,8);
				when 171 to 180=>
					bewegen(7)<=conv_std_logic_vector(128,8);
					bewegen(8)<=conv_std_logic_vector(246,8);
					bewegen(9)<=conv_std_logic_vector(9,8);
					bewegen(10)<=conv_std_logic_vector(60,8); 
					bewegen(11)<=conv_std_logic_vector(33,8);
					bewegen(12)<=conv_std_logic_vector(0,8);
					bewegen(13)<=conv_std_logic_vector(0,8);
				when others=>
					bewegen(0)<=conv_std_logic_vector(0,8);
					bewegen(1)<=conv_std_logic_vector(0,8);
					bewegen(2)<=conv_std_logic_vector(0,8);
					bewegen(3)<=conv_std_logic_vector(0,8); 
					bewegen(4)<=conv_std_logic_vector(0,8);
					bewegen(5)<=conv_std_logic_vector(0,8);
					bewegen(6)<=conv_std_logic_vector(0,8);
					bewegen(7)<=conv_std_logic_vector(0,8);
					bewegen(8)<=conv_std_logic_vector(0,8);
					bewegen(9)<=conv_std_logic_vector(0,8);
					bewegen(10)<=conv_std_logic_vector(0,8); 
					bewegen(11)<=conv_std_logic_vector(0,8);
					bewegen(12)<=conv_std_logic_vector(0,8);
					bewegen(13)<=conv_std_logic_vector(0,8);
			end case;		
			
	


-----------------------------------------------------------------------------------
--data an TXD senden
-----------------------------------------------------------------------------------

	LTxd_Done_1<= txd_done1;
	LTxd_Done_2<= txd_done2;
	LTxd_Done_3<= txd_done3;

	case Ram_state is
			when 0=>
				if motor1/= 14 then
					if LTxd_Done_1='1' and txd_done1<='0' then
						txd_data_1<=bewegen(motor1);
						motor1<=motor1+1;
					end if;
				else
					motor1<=0;
					Ram_state<=Ram_state+1;	
				end if;
			when 1=>
				if motor2/=14 then
					if LTxd_Done_1='1' and txd_done1<='0' then
						txd_data_2<=bewegen(motor2);
						motor2<=motor2+1;
					end if;
				else 
						motor2<=0;
						Ram_state<=Ram_state+1;	
				end if;
			when 2=>
				if motor3/=14 then
					if LTxd_Done_1='1' and txd_done1<='0' then
						txd_data_3<=bewegen(motor3);
						motor3<=motor3+1;
					end if;
				else 
					motor3<=0;
					luck<='1';
				end if;

	
			when others=>
	end case;
---------------------------------------------------------------------------------	
if luck='1' then

			if zzahler=8499999*10 then
				zzahler<=0;
				Ram_state_1<=Ram_state_1+2;
				Ram_state<=0;

		   else
				zzahler<=zzahler+1;

			end if;
		

end if;
end if;
end if;
end process;
END Behavioral;